package xyz.etztech.serverapi;

import xyz.etztech.serverapi.web.IProvider;
import xyz.etztech.serverapi.web.api.*;

import java.util.*;

public class MockProvider implements IProvider {
    List<WorldAPI> worlds;

    public MockProvider() {
        worlds = Arrays.asList(
                new WorldAPI("overworld", 1000, 10000, WorldAPI.WEATHER_CLEAR),
                new WorldAPI("nether", 1500, 15000, WorldAPI.WEATHER_STORM),
                new WorldAPI("end", 2000, 20000, WorldAPI.WEATHER_THUNDER)
        );
    }

    @Override
    public TPSAPI TPS() {
        return new TPSAPI(new LinkedList<>(Arrays.asList(20.0f, 15.0f, 10.0f, 18.0f, 20.0f)));
    }

    @Override
    public WorldAPI world(String name) {
        for (WorldAPI mock : worlds) {
            if (mock.getName().equalsIgnoreCase(name)) {
                return mock;
            }
        }
        return new WorldAPI("unknown", 0, 0, WorldAPI.WEATHER_CLEAR);
    }

    @Override
    public List<WorldAPI> worlds() {
        return worlds;
    }

    @Override
    public Set<BanAPI> bans() {
        long now = new Date().getTime();
        return new HashSet<>(Arrays.asList(
                new BanAPI("Etzelia", "Console", "Reasons", now, now),
                new BanAPI("Zero", "Notch", "lol lmao", now, now),
                new BanAPI("Vak", "Server", "brr", now, now)
        ));
    }

    @Override
    public void kick(BanAPI kick) {}

    @Override
    public void ban(BanAPI ban) {}

    @Override
    public void unban(BanAPI ban) {}

    @Override
    public void broadcast(BroadcastAPI broadcast) {}

    @Override
    public void custom(CustomAPI custom) {}

    @Override
    public Set<PlayerAPI> players() {
        return new HashSet<>(Arrays.asList(
                new PlayerAPI("Etzelia", "bf0446a8-9695-4c41-aa4c-7ff45bfd1171"),
                new PlayerAPI("Zero", "fe7e8413-2570-4588-9203-2b69ff188bc3"),
                new PlayerAPI("Vak", "7afbf663-2bf0-49ef-915f-22e81b298d17")
        ));
    }

    @Override
    public PingAPI ping() {
        return new PingAPI("Mock", "0.0.1", "Hello, world!", 0, 100);
    }

    @Override
    public List<PluginAPI> plugins() {
        return Arrays.asList(
                new PluginAPI("ServerAPI", "0.0.1", Collections.singletonList("Etzelia"), "https://git.etztech.xyz"),
                new PluginAPI("dynmap", "0.1.0", null, "https://www.spigotmc.org/resources/dynmap.274/"),
                new PluginAPI("CoreProtect", "1.0.0", Collections.singletonList("Intelli"), null)
        );
    }

    @Override
    public List<ChatAPI> chat() {
        long now = new Date().getTime();
        return Arrays.asList(
                new ChatAPI("message 1", now-2),
                new ChatAPI("message 2", now-1),
                new ChatAPI("message 3", now)
        );
    }

    @Override
    public void log(String message) {
        System.out.println(message);
    }
}
